#include<iostream>
#include<string>
#define MAXN 100000
#define K 400
using namespace std;
int a[MAXN],n;
int buckets[MAXN/K+1];
void build_buckets () {
    int ind=-1;
    for (int i=0; i<n; i++) {
        if (i%K==0) ind++;
        buckets[ind]+=a[i];
    }
}
int query (int l, int r) {
    int lind=l/K,rind=r/K;
    int sum=0;
    if (lind==rind) {
        for (int i=l; i<=r; i++) {
            sum+=a[i];
        }
    }
    else {
        for (int i=l; i<(lind+1)*K; i++) {
            sum+=a[i];
        }
        for (int i=lind+1; i<rind; i++) {
            sum+=buckets[i];
        }
        for (int i=rind*K; i<=r; i++) {
            sum+=a[i];
        }
    }
    return sum;
}
void update (int p, int v) {
    a[p]+=v;
    buckets[p/K]+=v;
}
int main () {
    cin >> n ;
    for (int i=0; i<n; i++) {
        cin >> a[i] ;
    }

    build_buckets();

    int q;
    cin >> q ;
    for (int i=0; i<q; i++) {
        string type;
        cin >> type ;
        if (type=="query") {
            int l,r;
            cin >> l >> r ;
            l--; r--;
            cout << query(l,r) << endl ;
        }
        else {
            int p,v;
            cin >> p >> v ;
            p--;
            update(p,v);
        }
    }
    return 0;
}
/*
10
6 3 2 5 1 8 9 4 10 7
6
query 4 5
query 2 8
update 4 -3
query 4 5
query 2 8
query 1 3
====================
6
32
3
29
11
*/
