#include<iostream>
#include<string>
#define MAXN 100000
#define K 400
using namespace std;
int a[MAXN],n;
struct bucket {
    int pref[K];
    int find_sum (int l, int r) {
        return pref[r]-((l==0)?0:pref[l-1]);
    }
};
bucket buckets[MAXN/K+1];
int pref[MAXN/K+1];
void build_buckets () {
    int ind=-1;
    for (int i=0; i<n; i++) {
        int curr=i%K;
        if (curr==0) {
            ind++;
            buckets[ind].pref[0]=a[i];
            if (ind>0) pref[ind]=pref[ind-1];
        }
        else buckets[ind].pref[curr]=buckets[ind].pref[curr-1]+a[i];
        pref[ind]+=a[i];
    }
}
int query (int l, int r) {
    int lind=l/K,rind=r/K;
    if (lind==rind) return buckets[lind].find_sum(l%K,r%K);
    int sum=0;
    sum+=buckets[lind].find_sum(l%K,K-1);
    sum+=pref[rind-1]-pref[lind];
    sum+=buckets[rind].find_sum(0,r%K);
    return sum;
}
void update (int p, int v) {
    int ind=p/K;
    for (int i=p%K; i<K; i++) {
        buckets[ind].pref[i]+=v;
    }
    for (int i=ind; i<=n/K; i++) {
        pref[i]+=v;
    }
}
int main () {
    cin >> n ;
    for (int i=0; i<n; i++) {
        cin >> a[i] ;
    }

    build_buckets();

    int q;
    cin >> q ;
    for (int i=0; i<q; i++) {
        string type;
        cin >> type ;
        if (type=="query") {
            int l,r;
            cin >> l >> r ;
            l--; r--;
            cout << query(l,r) << endl ;
        }
        else {
            int p,v;
            cin >> p >> v ;
            p--;
            update(p,v);
        }
    }
    return 0;
}
/*
10
6 3 2 5 1 8 9 4 10 7
6
query 4 5
query 2 8
update 4 -3
query 4 5
query 2 8
query 1 3
====================
6
32
3
29
11
*/
